
#include "headers.h"

int assembler (Edit *edited, BuildError *errors, char *name)
{
    int i = 0, j = 0, off = 0, abortLine = 0, buf = 0, param = 0, type[2] = {0}, data[2] = {0}, type1 = 0, data1 = 0, type2 = 0, data2 = 0, insDone = 0, mnemoPos = 0,
    cam = 0, nbLabels = 0, rows = edited->rows, *length = edited->length;
    unsigned int key = 0;
    unsigned short *output = NULL, ins = 0, data1r4 = 0, data2r8 = 0;
    char mnemo[10], buffer[22], isErr = 0, *line = NULL, **base = edited->base, canLink = 1;

    for (i=0;i<rows;i++)
    {
        line = (char*)malloc(length[i]+1);

        for (j=0;j<=length[i];j++)
        {
            line[j] = base[i][j];
            if (line[j]>='A' && line[j]<='Z')
                line[j]+=32;
        }

        off = strafeBetweenSpaces(line);
        if (line[off]==0)
            abortLine = 1;

        buf = length[i];
        if (buf>0)
            if (base[i][buf-1]==':')
                abortLine = 1;

        if (!abortLine)
        {
            ins = 0xFFFF;
            param = -1;
            for (j=0;j<10;j++)
                mnemo[j] = -1;

            mnemoPos = off;
            for (j=0;1;j++)
            {
                mnemo[j] = line[off+j];
                if (j>=9 || line[off+j]==0)
                {
                    param = 0;
                    break;
                }
                else if (line[off+j]==' ')
                {
                    j++;
                    break;
                }
            }
            mnemo[j] = 0;
            off+=j;
            off+=strafeBetweenSpaces(&line[off]);
            if (line[off]==0)
            {
                mnemo[j] = ' ';
                mnemo[j+1] = 0;
                param = 0;
            }

            if (strsearch(mnemo, "bf \0")==0)
            {
                if (base[i][mnemoPos+3]!=0)
                {
                    off = findLabelDisp(*edited, &base[i][mnemoPos+3], i, &buf)-2;
                    if (buf==1 && fitsInBits(off, 8))
                        ins = 0x8B00 | (off&0xFF);                                  // Bf label
                    else
                    {
                        addError(errors, i, LABEL_NOT_REACHEABLE);
                        isErr = 1;
                    }
                }
            }
            else if (strsearch(mnemo, "bf/s \0")==0)
            {
                if (base[i][mnemoPos+5]!=0)
                {
                    off = findLabelDisp(*edited, &base[i][mnemoPos+5], i, &buf)-1;
                    if (buf==1 && fitsInBits(off, 8))
                        ins = 0x8F00 | (off&0xFF);                                  // Bf/S label
                    else
                    {
                        addError(errors, i, LABEL_NOT_REACHEABLE);
                        isErr = 1;
                    }
                }
            }
            else if (strsearch(mnemo, "bt \0")==0)
            {
                if (base[i][mnemoPos+3]!=0)
                {
                    off = findLabelDisp(*edited, &base[i][mnemoPos+3], i, &buf)-2;
                    if (buf==1 && fitsInBits(off, 8))
                        ins = 0x8900 | (off&0xFF);                                  // Bt label
                    else
                    {
                        addError(errors, i, LABEL_NOT_REACHEABLE);
                        isErr = 1;
                    }
                }
            }
            else if (strsearch(mnemo, "bt/s \0")==0)
            {
                if (base[i][mnemoPos+5]!=0)
                {
                    off = findLabelDisp(*edited, &base[i][mnemoPos+5], i, &buf)-1;
                    if (buf==1 && fitsInBits(off, 8))
                        ins = 0x8D00 | (off&0xFF);                                  // Bt/S label
                    else
                    {
                        addError(errors, i, LABEL_NOT_REACHEABLE);
                        isErr = 1;
                    }
                }
            }
            else if (strsearch(mnemo, "bra \0")==0)
            {
                if (base[i][mnemoPos+4]!=0)
                {
                    off = findLabelDisp(*edited, &base[i][mnemoPos+4], i, &buf)-2;
                    if (buf==1 && fitsInBits(off, 12))
                        ins = 0xA000 | (off&0xFFF);                                 // Bra label
                    else
                    {
                        addError(errors, i, LABEL_NOT_REACHEABLE);
                        isErr = 1;
                    }
                }
            }
            else if (strsearch(mnemo, "bsr \0")==0)
            {
                if (base[i][mnemoPos+4]!=0)
                {
                    off = findLabelDisp(*edited, &base[i][mnemoPos+4], i, &buf)-1;
                    if (buf==1 && fitsInBits(off, 12))
                        ins = 0xB000 | (off&0xFFF);                                 // Bsr label
                    else
                    {
                        addError(errors, i, LABEL_NOT_REACHEABLE);
                        isErr = 1;
                    }
                }
            }

            else if (param!=0)
            {
                searchArgv(&line[off], &type[0], &data[0]);
                buf = searchComma(&line[off]);
                type1 = type[0];
                data1 = data[0];
                data1r4 = data1<<4;
                if (buf!=-1)
                {
                    off+=buf+1;
                    off+=strafeBetweenSpaces(&line[off]);
                    searchArgv(&line[off], &type[1], &data[1]);
                    param = 2;
                    type2 = type[1];
                    data2 = data[1];
                    data2r8 = data2<<8;
                }
                else
                    param = 1;

                if (type1==22 && type2==21 && param==2)
                {
                    addError(errors, i, COMMA_NO_ARGV);
                    param = 0;
                    isErr = 1;
                }
                if (type1==22 && param==2)
                {
                    addError(errors, i, NO_FIRST_ARGV);
                    param = 0;
                    isErr = 1;
                }
                if (type2==21 && param==2)
                {
                    addError(errors, i, NO_SECOND_ARGV);
                    param = 0;
                    isErr = 1;
                }

                for (j=0;j<param;j++)
                {
                    if (type[j]<0)
                    {
                        isErr = 1;
                        switch (type[j])
                        {
                        case -11:
                            addError(errors, i, STACK_POP_PUSH);
                            break;
                        case -12:
                            addError(errors, i, SIGN_IMM_NO_DAT);
                            break;
                        case -13:
                            addError(errors, i, RANDOM_AT);
                            break;
                        case -14:
                            addError(errors, i, RANDOM_AT_DISP);
                            break;
                        case -15:
                            addError(errors, i, RANDOM_AT_2);
                            break;
                        case -16:
                            addError(errors, i, R0_NO_ARGV);
                            break;
                        case -17:
                            addError(errors, i, RANDOM_AT_DISP_RN);
                            break;
                        case -18:
                            addError(errors, i, R0_RND_RN);
                            break;
                        case -19:
                            addError(errors, i, RN_INVALID_SYMBOL);
                            break;
                        case -20:
                            addError(errors, i, IMM_HEX_NO_DATA);
                            break;
                        }
                    }
                    if ((type[j]>=0 && type[j]<=3) && !(data[j]>=0 && data[j]<=15))
                    {
                        addError(errors, i, RN_OUT_OF_BOUNDS);
                        isErr = 1;
                    }
                    if (type[j]==_AtDispRN && !((data[j]>>16)>=0 && (data[j]>>16)<=15))
                    {
                        addError(errors, i, RN_OUT_OF_BOUNDS);
                        isErr = 1;
                    }
                    if (type[j]==_AtR0RN && !(data[j]>=0 && data[j]<=15))
                    {
                        addError(errors, i, RN_OUT_OF_BOUNDS);
                        isErr = 1;
                    }
                }
            }

            if (!isErr && ins==0xFFFF)
            {
                if (strsearch(mnemo, "mov\0")==0)
                {
                    j = 3;
                    if (mnemo[j]=='.')
                        j++;
                    if (param==2)
                    {
                        switch(mnemo[j])
                        {
                        case ' ':
                            if (type1==_IMM && type2==_RN)
                                if (fitsInSignedChar(data1))
                                    ins = 0xE000 | data2r8 | (data1&0xFF);                  // Mov #imm, Rn
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_2NIB);
                                    isErr = 1;
                                }

                            else if (type1==_RN && type2==_RN)
                                ins = 0x6003 | data2r8 | data1r4;                           // Mov Rm, Rn

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                            break;
                        case 'b':
                            if (type1==_RN && type2==_AtRN)
                                ins = 0x2000 | data2r8 | data1r4;                           // Mov.b Rm, @Rn

                            else if (type1==_AtRN && type2==_RN)
                                ins = 0x6000 | data2r8 | data1r4;                           // Mov.b @Rm, Rn

                            else if (type1==_RN && type2==_AtMinRN)
                                ins = 0x2004 | data2r8 | data1r4;                           // Mov.b Rm, @-Rn

                            else if (type1==_AtRNPlus && type2==_RN)
                                ins = 0x6004 | data2r8 | data1r4;                           // Mov.b @Rm+, Rn

                            else if (type1==_RN && data1==0 && type2==_AtDispRN)
                            {
                                if (fitsInSignedNibble(data2&0xFFFF))
                                    ins = 0x8000 | ((data2&0x000F0000)>>12) | (data2&0xF);  // Mov.b R0, &(disp, Rn)
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_1NIB);
                                    isErr = 1;
                                }
                            }

                            else if (type1==_AtDispRN && type2==_RN && data2==0)
                            {
                                if (fitsInSignedNibble(data1&0xFFFF))
                                    ins = 0x8400 | ((data1&0x000F0000)>>12) | (data1&0xF);  // Mov.b @(disp, Rm), R0
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_1NIB);
                                    isErr = 1;
                                }
                            }

                            else if (type1==_RN && type2==_AtR0RN)
                                ins = 0x0004 | data2r8 | data1r4;                           // Mov.b Rm, @(R0, Rn)

                            else if (type1==_AtR0RN && type2==_RN)
                                ins = 0x000C | data2r8 | data1r4;                           // Mov.b @(R0, Rm), Rn

                            else if (type1==_RN && data1==0 && type2==_AtDispGBR)
                                ins = 0xC000 | (((char)data2)&0xFF);                        // Mov.b R0, @(disp, GBR)

                            else if (type1==_AtDispGBR && type2==_RN && data2==0)
                                ins = 0xC400 | (((char)data1)&0xFF);                        // Mov.b @(disp, GBR), R0

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                            break;
                        case 'w':
                            if (type1==_AtDispPC && type2==_RN)
                                if (fitsInSignedChar(data1))
                                    ins = 0x9000 | data2r8 | (data1&0xFF);                  // Mov.w @(disp,PC), Rn
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_2NIB);
                                    isErr = 1;
                                }

                            else if (type1==_RN && type2==_AtRN)
                                ins = 0x2001 | data2r8 | data1r4;                           // Mov.w Rm, @Rn

                            else if (type1==_AtRN && type2==_RN)
                                ins = 0x6001 | data2r8 | data1r4;                           // Mov.w @Rm, Rn

                            else if (type1==_RN && type2==_AtMinRN)
                                ins = 0x2005 | data2r8 | data1r4;                           // Mov.w Rm, @-Rn

                            else if (type1==_AtRNPlus && type2==_RN)
                                ins = 0x6005 | data2r8 | data1r4;                           // Mov.w @Rm+, Rn

                            else if (type1==_RN && data1==0 && type2==_AtDispRN)
                            {
                                if (fitsInSignedNibble(data2&0xFFFF))
                                    ins = 0x8100 | ((data2&0x000F0000)>>12) | (data2&0xF);  // Mov.w R0, &(disp, Rn)
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_1NIB);
                                    isErr = 1;
                                }
                            }

                            else if (type1==_AtDispRN && type2==_RN && data2==0)
                            {
                                if (fitsInSignedNibble(data1&0xFFFF))
                                        ins = 0x8500 | ((data1&0x000F0000)>>12) | (data1&0xF);  // Mov.w @(disp, Rm), R0
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_1NIB);
                                    isErr = 1;
                                }
                            }

                            else if (type1==_RN && type2==_AtR0RN)
                                ins = 0x0005 | data2r8 | data1r4;                           // Mov.w Rm, @(R0, Rn)

                            else if (type1==_AtR0RN && type2==_RN)
                                ins = 0x000D | data2r8 | data1r4;                           // Mov.w @(R0, Rm), Rn

                            else if (type1==_RN && data1==0 && type2==_AtDispGBR)
                                ins = 0xC100 | (((char)data2)&0xFF);                        // Mov.w R0, @(disp, GBR)

                            else if (type1==_AtDispGBR && type2==_RN && data2==0)
                                ins = 0xC500 | (((char)data1)&0xFF);                        // Mov.w @(disp, GBR), R0

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                            break;
                        case 'l':
                            if (type1==_AtDispPC && type2==_RN)
                            {
                                if (fitsInSignedChar(data1))
                                    ins = 0xD000 | data2r8 | (data1&0xFF);                  // Mov.l @(disp,PC), Rn
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_2NIB);
                                    isErr = 1;
                                }
                            }

                            else if (type1==_RN && type2==_AtRN)
                                ins = 0x2002 | data2r8 | data1r4;                           // Mov.l Rm, @Rn

                            else if (type1==_AtRN && type2==_RN)
                                ins = 0x6002 | data2r8 | data1r4;                           // Mov.l @Rm, Rn

                            else if (type1==_RN && type2==_AtMinRN)
                                ins = 0x2006 | data2r8 | data1r4;                           // Mov.l Rm, @-Rn

                            else if (type1==_AtRNPlus && type2==_RN)
                                ins = 0x6006 | data2r8 | data1r4;                           // Mov.l @Rm+, Rn

                            else if (type1==_RN && type2==_AtDispRN)
                            {
                                if (fitsInSignedNibble(data2&0xFFFF))
                                    ins = 0x1000 | ((data2&0x000F0000)>>8) | (data1<<4) | (data2&0xF);  // Mov.w R0, &(disp, Rn)
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_1NIB);
                                    isErr = 1;
                                }
                            }

                            else if (type1==_AtDispRN && type2==_RN)
                            {
                                if (fitsInSignedNibble(data1&0xFFFF))
                                    ins = 0x5000 | data2r8 | ((data1&0x000F0000)>>12) | (data1&0xF);    // Mov.l @(disp, Rm), Rn
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_1NIB);
                                    isErr = 1;
                                }
                            }

                            else if (type1==_RN && type2==_AtR0RN)
                                ins = 0x0006 | data2r8 | data1r4;                           // Mov.l Rm, @(R0, Rn)

                            else if (type1==_AtR0RN && type2==_RN)
                                ins = 0x000E | data2r8 | data1r4;                           // Mov.l @(R0, Rm), Rn

                            else if (type1==_RN && data1==0 && type2==_AtDispGBR)
                                ins = 0xC200 | (((char)data2)&0xFF);                        // Mov.l R0, @(disp, GBR)

                            else if (type1==_AtDispGBR && type2==_RN && data2==0)
                                ins = 0xC600 | (((char)data1)&0xFF);                        // Mov.l @(disp, GBR), R0

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                            break;
                        case 'a':
                            if (type1==_AtDispPC && type2==_RN && data2==0)
                                ins = 0xC700 | (((char)data1)&0xFF);                        // MovA @(disp,PC), R0

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                            break;
                        default:
                            addError(errors, i, DAFUK_MNEMO);
                            isErr = 1;
                            break;
                        }
                    }
                    else if (param==1)
                    {
                        switch(mnemo[3])
                        {
                        case 't':
                            if (type1==_RN)
                                ins = 0x0029 | (data1<<8);                                  // MovT Rn

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                            break;
                        default:
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                            break;
                        }
                    }
                    else
                    {
                        addError(errors, i, ARGV_MISSING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "pref \0")==0)
                {
                    if (param==1 && type1==_AtRN)
                        ins = 0x0083 | (data1<<8);                                          // Pref @Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "swap\0")==0)
                {
                    if (param==2 && mnemo[4]=='.' && mnemo[6]==' ' && type1==_RN && type2==_RN)
                    {
                        switch(mnemo[5])
                        {
                        case 'b':
                            ins = 0x6008 | data1r4 | data2r8;                               // Swap.b Rm, Rn
                            break;
                        case 'w':
                            ins = 0x6009 | data1r4 | data2r8;                               // Swap.w Rm, Rn
                            break;
                        default:
                            addError(errors, i, DAFUK_MNEMO);
                            isErr = 1;
                            break;
                        }
                    }
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "xtrct \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x200D | data1r4 | data2r8;                                   // Xtrct Rm, Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "add\0")==0)
                {
                    if (param==2 && mnemo[4]==' ')
                    {
                        switch(mnemo[3])
                        {
                        case ' ':
                            if (type1==_RN && type2==_RN)
                                ins = 0x300C | data1r4 | data2r8;                           // Add Rm, Rn

                            else if (type1==_IMM && type2==_RN)
                            {
                                if (fitsInSignedChar(data1))
                                    ins = 0x7000  | data2r8 | (data1&0xFF);                 // Add #imm, Rn
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_2NIB);
                                    isErr = 1;
                                }
                            }

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                            break;
                        case 'c':
                            if (type1==_RN && type2==_RN)
                                ins = 0x300E | data1r4 | data2r8;                           // AddC Rm, Rn

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                            break;
                        case 'v':
                            if (type1==_RN && type2==_RN)
                                ins = 0x300F | data1r4 | data2r8;                           // AddV Rm, Rn

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                            break;
                        default:
                            addError(errors, i, DAFUK_MNEMO);
                            isErr = 1;
                            break;
                        }
                    }
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "cmp/\0")==0)
                {
                    if (mnemo[3]=='/')
                    {
                        if (strsearch(mnemo+4, "eq \0")==0)
                        {
                            if (type1==_IMM && type2==_RN && data2==0)
                            {
                                if (fitsInSignedChar(data1))
                                    ins = 0x8800 | (data1&0xFF);                            // Cmp/eq #imm, R0
                                else
                                {
                                    addError(errors, i, DAT_TOO_LARGE_2NIB);
                                    isErr = 1;
                                }
                            }
                            else if (type1==_RN && type2==_RN)
                                ins = 0x3000 | data1r4 | data2r8;                           // Cmp/eq Rm, Rn

                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                        }
                        else if (strsearch(mnemo+4, "hs \0")==0)
                            if (param==2 && type1==_RN && type2==_RN)
                                ins = 0x3002  | data1r4 | data2r8;                          // Cmp/hs Rm, Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                        else if (strsearch(mnemo+4, "ge \0")==0)
                            if (param==2 && type1==_RN && type2==_RN)
                                ins = 0x3003  | data1r4 | data2r8;                          // Cmp/ge Rm, Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                        else if (strsearch(mnemo+4, "hi \0")==0)
                            if (param==2 && type1==_RN && type2==_RN)
                                ins = 0x3006  | data1r4 | data2r8;                          // Cmp/hi Rm, Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                        else if (strsearch(mnemo+4, "gt \0")==0)
                            if (param==2 && type1==_RN && type2==_RN)
                                ins = 0x3007  | data1r4 | data2r8;                          // Cmp/gt Rm, Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                        else if (strsearch(mnemo+4, "str \0")==0)
                            if (param==2 && type1==_RN && type2==_RN)
                                ins = 0x200C  | data1r4 | data2r8;                          // Cmp/str Rm, Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                        else if (strsearch(mnemo+4, "pz \0")==0)
                            if (param==1 && type1==_RN)
                                ins = 0x4011  | (data1<<8);                                 // Cmp/pz Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                        else if (strsearch(mnemo+4, "pl \0")==0)
                            if (param==1 && type1==_RN)
                                ins = 0x4015  | (data1<<8);                                 // Cmp/pl Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }

                        else
                        {
                            addError(errors, i, DAFUK_MNEMO);
                            isErr = 1;
                        }
                    }
                    else
                    {
                        addError(errors, i, CMP_TYPICAL);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "div1 \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x3004 | data1r4 | data2r8;                                   // Div1 Rm, Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "div0s \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x2007 | data1r4 | data2r8;                                   // Div0S Rm, Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "div0u\0")==0 && (mnemo[5]==0 || mnemo[5]==' '))
                {
                    if (param==0)
                        ins = 0x0019;                                                       // Div0U
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "dmuls.l \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x300D | data1r4 | data2r8;                                   // DmulS.l Rm, Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "dmulu.l \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x3005 | data1r4 | data2r8;                                   // DmulU.l Rm, Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "dt \0")==0)
                {
                    if (param==1 && type1==_RN)
                        ins = 0x4010 | (data1<<8);                                          // Dt Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "exts.\0")==0)
                {
                    switch(mnemo[5])
                    {
                    case 'b':
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x600E | data1r4 | data2r8;                               // ExtS.b Rm, Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    case 'w':
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x600F | data1r4 | data2r8;                               // ExtS.w Rm, Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    default:
                        addError(errors, i, DAFUK_MNEMO);
                        isErr = 1;
                        break;
                    }
                }
                else if (strsearch(mnemo, "extu.\0")==0)
                {
                    switch(mnemo[5])
                    {
                    case 'b':
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x600C | data1r4 | data2r8;                               // ExtU.b Rm, Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    case 'w':
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x600D | data1r4 | data2r8;                               // ExtU.w Rm, Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    default:
                        addError(errors, i, DAFUK_MNEMO);
                        isErr = 1;
                        break;
                    }
                }
                else if (strsearch(mnemo, "mac.\0")==0)
                {
                    switch(mnemo[4])
                    {
                    case 'l':
                        if (param==2 && type1==_AtRNPlus && type2==_AtRNPlus)
                            ins = 0x000F | data1r4 | data2r8;                               // Mac.l @Rm+, @Rn+
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    case 'w':
                        if (param==2 && type1==_AtRNPlus && type2==_AtRNPlus)
                            ins = 0x400F | data1r4 | data2r8;                               // Mac.w @Rm+, @Rn+
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                        break;
                    default:
                        addError(errors, i, DAFUK_MNEMO);
                        isErr = 1;
                        break;
                    }
                }
                else if (strsearch(mnemo, "mul.l \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x0007 | data1r4 | data2r8;                                   // Mul.l Rm, Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "muls.w \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x200F | data1r4 | data2r8;                                   // MulS.w Rm, Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "mulu.w \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x200E | data1r4 | data2r8;                                   // MulU.w Rm, Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "neg\0")==0)
                {
                    switch(mnemo[3])
                    {
                    case ' ':
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x600B | data1r4 | data2r8;                               // Neg Rm, Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    case 'c':
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x600A | data1r4 | data2r8;                               // NegC Rm, Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    default:
                        addError(errors, i, DAFUK_MNEMO);
                        isErr = 1;
                        break;
                    }
                }
                else if (strsearch(mnemo, "sub\0")==0)
                {
                    switch(mnemo[3])
                    {
                    case ' ':
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x3008 | data1r4 | data2r8;                               // Sub Rm, Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    case 'c':
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x300A | data1r4 | data2r8;                               // SubC Rm, Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    case 'v':
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x300B | data1r4 | data2r8;                               // SubV Rm, Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                        break;
                    default:
                        addError(errors, i, DAFUK_MNEMO);
                        isErr = 1;
                        break;
                    }
                }
                else if (strsearch(mnemo, "and \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x2009 | data1r4 | data2r8;                                   // And Rm, Rn

                    else if (param==2 && type1==_IMM && type2==_RN && data2==0)
                    {
                        if (fitsInSignedChar(data1))
                            ins = 0xC900 | (data1&0xFF);                                    // And #imm, R0
                        else
                        {
                            addError(errors, i, DAT_TOO_LARGE_2NIB);
                            isErr = 1;
                        }
                    }
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "and.b \0")==0)
                {
                    if (param==2 && type1==_IMM && type2==_AtRNGBR && data2==0)
                    {
                        if (fitsInSignedChar(data1))
                            ins = 0xCD00 | (data1&0xFF);                                    // And.b #imm, @(R0, GBR)
                        else
                        {
                            addError(errors, i, DAT_TOO_LARGE_2NIB);
                            isErr = 1;
                        }
                    }
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "not \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x6007 | data1r4 | data2r8;                                   // Not Rm, Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "or \0")==0)
                {
                    if (param==2 && type1==_RN && type2==_RN)
                        ins = 0x200B | data1r4 | data2r8;                                   // Or Rm, Rn

                    else if (param==2 && type1==_IMM && type2==_RN && data2==0)
                    {
                        if (fitsInSignedChar(data1))
                            ins = 0xCB00 | (data1&0xFF);                                    // Or #imm, R0
                        else
                        {
                            addError(errors, i, DAT_TOO_LARGE_2NIB);
                            isErr = 1;
                        }
                    }
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "or.b \0")==0)
                {
                    if (param==2 && type1==_IMM && type2==_AtRNGBR && data2==0)
                    {
                        if (fitsInSignedChar(data1))
                            ins = 0xCF00 | (data1&0xFF);                                    // Or.b #imm, @(R0, GBR)
                        else
                        {
                            addError(errors, i, DAT_TOO_LARGE_2NIB);
                            isErr = 1;
                        }
                    }
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                else if (strsearch(mnemo, "tas.b \0")==0)
                {
                    if (param==1 && type1==_AtRN)
                        ins = 0x401B | (data1<<8);                                          // Tas.b @Rn
                    else
                    {
                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                        isErr = 1;
                    }
                }
                if (ins==0xFFFF && !isErr)
                {
                    if (strsearch(mnemo, "tst \0")==0)
                    {
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x2008 | data1r4 | data2r8;                               // Tst Rm, Rn

                        else if (param==2 && type1==_IMM && type2==_RN && data2==0)
                        {
                            if (fitsInSignedChar(data1))
                                ins = 0xC800 | (data1&0xFF);                                // Tst #imm, R0
                            else
                            {
                                addError(errors, i, DAT_TOO_LARGE_2NIB);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "tst.b \0")==0)
                    {
                        if (param==2 && type1==_IMM && type2==_AtRNGBR && data2==0)
                        {
                            if (fitsInSignedChar(data1))
                                ins = 0xCC00 | (data1&0xFF);                                // Tst.b #imm, @(R0, GBR)
                            else
                            {
                                addError(errors, i, DAT_TOO_LARGE_2NIB);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "xor \0")==0)
                    {
                        if (param==2 && type1==_RN && type2==_RN)
                            ins = 0x200A | data1r4 | data2r8;                               // Xor Rm, Rn

                        else if (param==2 && type1==_IMM && type2==_RN && data2==0)
                        {
                            if (fitsInSignedChar(data1))
                                ins = 0xCA00 | (data1&0xFF);                                // Xor #imm, R0
                            else
                            {
                                addError(errors, i, DAT_TOO_LARGE_2NIB);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "xor.b \0")==0)
                    {
                        if (param==2 && type1==_IMM && type2==_AtRNGBR && data2==0)
                        {
                            if (fitsInSignedChar(data1))
                                ins = 0xCE00 | (data1&0xFF);                                // Xor.b #imm, @(R0, GBR)
                            else
                            {
                                addError(errors, i, DAT_TOO_LARGE_2NIB);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "rot\0")==0)
                    {
                        if (param==1 && type1==_RN)
                        {
                            if (strsearch(mnemo+3, "l \0")==0)
                                ins = 0x4004 | (data1<<8);                                  // RotL Rn

                            else if (strsearch(mnemo+3, "r \0")==0)
                                ins = 0x4005 | (data1<<8);                                  // RotR Rn

                            else if (strsearch(mnemo+3, "cl \0")==0)
                                ins = 0x4024 | (data1<<8);                                  // RotCL Rn

                            else if (strsearch(mnemo+3, "cr \0")==0)
                                ins = 0x4025 | (data1<<8);                                  // RotCT Rn

                            else
                            {
                                addError(errors, i, DAFUK_MNEMO);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "sha\0")==0 && mnemo[4]==' ')
                    {
                        switch (mnemo[3])
                        {
                        case 'd':
                            if (param==2 && type1==_RN && type2==_RN)
                                ins = 0x400C | data1r4 | data2r8;                           // ShaD Rm, Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                            break;
                        case 'l':
                            if (param==1 && type1==_RN)
                                ins = 0x4020 | (data1<<8);                                  // ShaL Rm, Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                            break;
                        case 'r':
                            if (param==1 && type1==_RN)
                                ins = 0x4021 | (data1<<8);                                  // ShaR Rm, Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                            break;
                        default:
                            addError(errors, i, DAFUK_MNEMO);
                            isErr = 1;
                            break;
                        }
                    }
                    else if (strsearch(mnemo, "shl\0")==0)
                    {
                        if (strsearch(mnemo+3, "d \0")==0)
                        {
                            if (param==2 && type1==_RN && type2==_RN)
                                ins = 0x400D | data1r4 | data2r8;                           // ShlD Rm, Rn
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                        }
                        else if (param==1 && type1==_RN)
                        {
                            if (strsearch(mnemo+3, "l \0")==0)
                                ins = 0x2000 | (data1<<8);                                  // ShlL Rn

                            else if (strsearch(mnemo+3, "r \0")==0)
                                ins = 0x2001 | (data1<<8);                                  // ShlR Rn

                            else if (strsearch(mnemo+3, "l2 \0")==0)
                                ins = 0x2010 | (data1<<8);                                  // ShlL2 Rn

                            else if (strsearch(mnemo+3, "r2 \0")==0)
                                ins = 0x2011 | (data1<<8);                                  // ShlR2 Rn

                            else if (strsearch(mnemo+3, "l8 \0")==0)
                                ins = 0x2030 | (data1<<8);                                  // ShlL8 Rn

                            else if (strsearch(mnemo+3, "r8 \0")==0)
                                ins = 0x2031 | (data1<<8);                                  // ShlR8 Rn

                            else if (strsearch(mnemo+3, "l16 \0")==0)
                                ins = 0x2050 | (data1<<8);                                  // ShlL16 Rn

                            else if (strsearch(mnemo+3, "r16 \0")==0)
                                ins = 0x2051 | (data1<<8);                                  // ShlR16 Rn

                            else
                            {
                                addError(errors, i, DAFUK_MNEMO);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }

                    else if (strsearch(mnemo, "braf \0")==0)
                    {
                        if (param==1 && type1==_RN)
                            ins = 0x0023 | (data1<<8);                                      // BraF Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "bsrf \0")==0)
                    {
                        if (param==1 && type1==_RN)
                            ins = 0x0003 | (data1<<8);                                      // BsrF Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "jmp \0")==0)
                    {
                        if (param==1 && type1==_AtRN)
                            ins = 0x402B | (data1<<8);                                      // Jmp &Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "jsr \0")==0)
                    {
                        if (param==1 && type1==_AtRN)
                            ins = 0x400B | (data1<<8);                                      // Jsr @Rn
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "rts\0")==0 && (mnemo[3]==0 || mnemo[3]==' '))
                    {
                        if (param==0)
                            ins = 0x000B;                                                   // Rts
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "clr\0")==0)
                    {
                        if (param==0)
                        {
                            if (strsearch(mnemo+3, "mac\0")==0 && (mnemo[6]==0 || mnemo[6]==' '))
                                ins = 0x0028;                                               // ClrMac

                            else if (mnemo[3]=='s' && (mnemo[4]==0 || mnemo[4]==' '))
                                ins = 0x0028;                                               // ClrS

                            else if (mnemo[3]=='t' && (mnemo[4]==0 || mnemo[4]==' '))
                                ins = 0x0028;                                               // ClrT

                            else
                            {
                                addError(errors, i, DAFUK_MNEMO);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "nop\0")==0 && (mnemo[3]==0 || mnemo[3]==' '))
                    {
                        if (param==0)
                            ins = 0x0009;                                                   // Nop
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "sleep\0")==0 && (mnemo[5]==0 || mnemo[5]==' '))
                    {
                        if (param==0)
                            ins = 0x001B;                                                   // Sleep
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "set\0")==0 && (mnemo[4]==0 || mnemo[4]==' '))
                    {
                        if (param==0)
                        {
                            if (mnemo[3]=='s')                                              // SetS
                                ins = 0x0058;

                            else if (mnemo[3]=='t')
                                ins = 0x0018;                                               // SetT

                            else
                            {
                                addError(errors, i, DAFUK_MNEMO);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                            isErr = 1;
                        }
                    }
                    else if (strsearch(mnemo, "ldc\0")==0)
                    {
                        j = 3;
                        if (mnemo[j]=='.')
                            j++;

                        if (mnemo[j+1]==' ')
                        {
                            if (param==2)
                            {
                                switch (mnemo[j])
                                {
                                case ' ':
                                    if (type1==_RN && type2==_SR)
                                        ins = 0x400E | (data1<<8);                          // LdC Rm, SR

                                    else if (type1==_RN && type2==_GBR)
                                        ins = 0x401E | (data1<<8);                          // LdC Rm, GBR

                                    else
                                    {
                                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                        isErr = 1;
                                    }

                                    break;
                                case 'l':
                                    if (type1==_AtRNPlus && type2==_SR)
                                        ins = 0x4007 | (data1<<8);                          // LdC.l @Rm+, SR

                                    else if (type1==_AtRNPlus && type2==_GBR)
                                        ins = 0x4017 | (data1<<8);                          // LdC.l @Rm+, GBR

                                    else
                                    {
                                        addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                        isErr = 1;
                                    }

                                    break;
                                default:
                                    addError(errors, i, DAFUK_MNEMO);
                                    isErr = 1;
                                    break;
                                }
                            }
                            else
                            {
                                addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, DAFUK_MNEMO);
                            isErr = 1;
                        }
                    }
                    if (ins==0xFFFF && !isErr)
                    {
                        if (strsearch(mnemo, "lds\0")==0)
                        {
                            j = 3;
                            if (mnemo[j]=='.')
                                j++;

                            if (mnemo[j+1]==' ')
                            {
                                if (param==2)
                                {
                                    switch (mnemo[j])
                                    {
                                    case ' ':
                                        if (type1==_RN && type2==_MACH)
                                            ins = 0x400A | (data1<<8);                          // LdS Rm, MacH

                                        else if (type1==_RN && type2==_MACL)
                                            ins = 0x401A | (data1<<8);                          // LdS Rm, MacL

                                        else if (type1==_RN && type2==_PR)
                                            ins = 0x402A | (data1<<8);                          // LdS Rm, PR

                                        else
                                        {
                                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                            isErr = 1;
                                        }

                                        break;
                                    case 'l':
                                        if (type1==_AtRNPlus && type2==_MACH)
                                            ins = 0x4006 | (data1<<8);                          // LdS.l @Rm+, MacH

                                        else if (type1==_AtRNPlus && type2==_MACL)
                                            ins = 0x4016 | (data1<<8);                          // LdS.l @Rm+, MacL

                                        else if (type1==_AtRNPlus && type2==_PR)
                                            ins = 0x4026 | (data1<<8);                          // LdS.l @Rm+, MacPR

                                        else
                                        {
                                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                            isErr = 1;
                                        }

                                        break;
                                    default:
                                        addError(errors, i, DAFUK_MNEMO);
                                        isErr = 1;
                                        break;
                                    }
                                }
                                else
                                {
                                    addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                    isErr = 1;
                                }
                            }
                            else
                            {
                                addError(errors, i, DAFUK_MNEMO);
                                isErr = 1;
                            }
                        }
                        else if (strsearch(mnemo, "stc\0")==0)
                        {
                            j = 3;
                            if (mnemo[j]=='.')
                                j++;

                            if (mnemo[j+1]==' ')
                            {
                                if (param==2)
                                {
                                    switch (mnemo[j])
                                    {
                                    case ' ':
                                        if (type1==_SR && type2==_RN)
                                            ins = 0x0002 | (data1<<8);                          // StC SR, Rn

                                        else if (type1==_GBR && type2==_RN)
                                            ins = 0x0012 | (data1<<8);                          // StC GBR, Rn

                                        else
                                        {
                                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                            isErr = 1;
                                        }

                                        break;
                                    case 'l':
                                        if (type1==_SR && type2==_AtMinRN)
                                            ins = 0x4003 | (data1<<8);                          // StC.l SR, @-Rn

                                        else if (type1==_GBR && type2==_AtMinRN)
                                            ins = 0x4013 | (data1<<8);                          // StC.l GBR, @-Rn

                                        else
                                        {
                                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                            isErr = 1;
                                        }

                                        break;
                                    default:
                                        addError(errors, i, DAFUK_MNEMO);
                                        isErr = 1;
                                        break;
                                    }
                                }
                                else
                                {
                                    addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                    isErr = 1;
                                }
                            }
                            else
                            {
                                addError(errors, i, DAFUK_MNEMO);
                                isErr = 1;
                            }
                        }
                        else if (strsearch(mnemo, "sts\0")==0)
                        {
                            j = 3;
                            if (mnemo[j]=='.')
                                j++;

                            if (mnemo[j+1]==' ')
                            {
                                if (param==2)
                                {
                                    switch (mnemo[j])
                                    {
                                    case ' ':
                                        if (type1==_MACH && type2==_RN)
                                            ins = 0x000A | (data1<<8);                          // StS MacH, Rn

                                        else if (type1==_MACL && type2==_RN)
                                            ins = 0x001A | (data1<<8);                          // StS MacL, Rn

                                        else if (type1==_PR && type2==_RN)
                                            ins = 0x002A | (data1<<8);                          // StS PR, Rn

                                        else
                                        {
                                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                            isErr = 1;
                                        }

                                        break;
                                    case 'l':
                                        if (type1==_MACH && type2==_AtMinRN)
                                            ins = 0x4002 | (data1<<8);                          // StS/l MacH, @-Rn

                                        else if (type1==_MACL && type2==_AtMinRN)
                                            ins = 0x4012 | (data1<<8);                          // StS/l MacL, @-Rn

                                        else if (type1==_PR && type2==_AtMinRN)
                                            ins = 0x4022 | (data1<<8);                          // StS/l PR, @-Rn

                                        else
                                        {
                                            addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                            isErr = 1;
                                        }

                                        break;
                                    default:
                                        addError(errors, i, DAFUK_MNEMO);
                                        isErr = 1;
                                        break;
                                    }
                                }
                                else
                                {
                                    addError(errors, i, ARGV_MNEMO_NOT_MATCHING);
                                    isErr = 1;
                                }
                            }
                            else
                            {
                                addError(errors, i, DAFUK_MNEMO);
                                isErr = 1;
                            }
                        }
                        else
                        {
                            addError(errors, i, WTF);
                            isErr = 1;
                        }
                    }
                }
            }
        }

        if (isErr)
            canLink = 0;

        if (!(abortLine || isErr))
        {
            output = (unsigned short*)realloc(output, (insDone+1)*sizeof(unsigned short));
            output[insDone] = ins;
            insDone++;
        }
        else if (!abortLine)
        {
            output = (unsigned short*)realloc(output, (insDone+1)*sizeof(unsigned short));
            output[insDone] = 0xFFFF;
            insDone++;
        }

        ML_clear_vram();

        for (j=0;j<8;j++)
        {
            if (insDone+j-8>=0)
            {
                locate(1, j+1);
                if (output[insDone+j-8]!=0xFFFF)
                {
                    itoa(buffer, (insDone+j-8)*2, 1 | (8<<2));
                    buffer[8] = ' ';
                    locate(1, j+1);
                    itoa(buffer+9, output[insDone+j-8], 1 | (4<<2));
                    buffer[13] = 0;
                    if (j!=7)
                        Print((unsigned char*)buffer);
                    else
                        PrintRev((unsigned char*)buffer);
                }
                else
                {
                    if (j!=7)
                        Print((unsigned char*)"// ERR\0");
                    else
                        PrintRev((unsigned char*)"// ERR\0");
                }
            }
        }

        ML_display_vram();

        abortLine = 0;
        isErr = 0;

        free(line);
    }

    cam = insDone-1;
    while (1)
    {
        if (key==KEY_CTRL_UP)
        {
            cam--;
            if (cam<0)
                cam = 0;
        }
        if (key==KEY_CTRL_DOWN)
        {
            cam++;
            if (cam>=insDone)
                cam = insDone-1;
        }

        if (key==KEY_CTRL_F6)
        {
            saveFile(*edited, name);

            for (i=0;i<edited->rows;i++)
            {
                free(edited->base[i]);
                edited->base[i] = 0;
            }

            free(edited->alloc);
            edited->alloc = 0;
            free(edited->length);
            edited->length = 0;
            free(edited->base);
            edited->base = 0;
            edited->rows = 0;
            edited->rowsAlloc = 0;

            linker((char*)output, 0x20C + (insDone*2));

            return 1;
        }

        if (key==KEY_CTRL_EXE)
            break;

        ML_clear_vram();

        for (j=0;j<8;j++)
        {
            buf = cam+j-6;
            if ((buf>=0) && (buf<insDone))
            {
                itoa(buffer, buf*2, 1 | (8<<2));
                buffer[8] = ' ';
                locate(1, j+1);
                if (output[buf]!=0xFFFF)
                {
                    itoa(buffer+9, output[buf], 1 | (4<<2));
                    buffer[13] = 0;
                    if (j!=6)
                        Print((unsigned char*)buffer);
                    else
                        PrintRev((unsigned char*)buffer);
                }
                else
                {
                    if (j!=6)
                        Print((unsigned char*)"// ERR\0");
                    else
                        PrintRev((unsigned char*)"// ERR\0");
                }
            }
        }

        if (canLink)
        {
            locate(16, 7);
            Print((unsigned char*)("Link :\0"));
            locate(16, 8);
            PrintRev((unsigned char*)("[F6]"));
        }

        ML_display_vram();
        GetKey(&key);
    }

    free(output);

    return 0;
}

int strsearch (char *searched, char *toFind)
{
    int len1 = 0, len2 = 0, max = 0, i = 0, j = 0, found = 0;
    char first = *toFind;

    len1 = strlen(searched);
    len2 = strlen(toFind);
    if (len1>len2)
        max = len2;
    else
        max = len1;

    for (i=0;i<len1;i++)
    {
        if (searched[i]==first)
        {
            found = 1;
            for (j=0;j<len2;j++)
            {
                if (searched[i+j]!=toFind[j])
                {
                    found = 0;
                    break;
                }
            }
            if(found)
                break;
        }
    }
    if (found)
        return i;
    else
        return -1;
}

int searchValue (char *buf, int *length, char *found)
{
    int i = 0, j = 0, len = 0, isNeg = 0, power10 = 1;
    char current = 0, nibble = 0;
    int result = 0;

    for (i=0;buf[i]!=0 && buf[i]!='(' && buf[i]!=')' && buf[i]!=',';i++)
    {
        if (buf[i]=='*')
        {
            i++;
            for (len=0;1;len++)
            {
                if (!((buf[i+len]>='0' && buf[i+len]<='9') || (buf[i+len]>='a' && buf[i+len]<='f')))
                    break;
            }
            current = buf[i];
            if (current=='8' || current=='9' || (current>='a' && current<='f'))
                isNeg = 1;

            for (j=0;j<len;j++)
            {
                current = buf[i+j];
                if (current>='0' && current<='9')
                    nibble = current-'0';
                if (current>='a' && current<='f')
                    nibble = current-'a'+10;
                result+=(nibble<<((len-j-1)*4));
            }
            if (isNeg)
                for (j=0;j<8-len;j++)
                    result |= 0xF<<((7-j)*4);

            *found = 1;
            break;
        }
        if (buf[i]=='-' || (buf[i]>='0' && buf[i]<='9'))
        {
            if (buf[i]=='-')
            {
                isNeg = 1;
                i++;
            }
            for (len=0;1;len++)
            {
                if (!(buf[i+len]>='0' && buf[i+len]<='9'))
                    break;
            }
            result = 0;
            for (j=0;j<len;j++)
            {
                result+=(power10*(buf[i+len-j-1]-'0'));
                power10*=10;
            }

            if (isNeg)
            {
                result = ~result;
                result++;
            }
            *found = 1;
            break;
        }
    }
    *length = len;
    return result;
}

int pow10 (int pwr)
{
    int result = 1, i = 0;

    for (i=0;i<pwr;i++)
        result*=10;

    return result;
}

void searchArgv (char *buf, int *type, int *data)
{
    int i = 0, j = 0, len = 0, tp = 0, dt = 0, isNeg = 0, parenthesis = 0;
    char current = 0, nibble = 0, found = 0;
    int result = 0;

    if (strsearch(buf, "gbr\0")==0)
        if (buf[3]==',' || buf[3]==0 || buf[3]==' ')
        {
            *type = _GBR;
            return;
        }
    else if (strsearch(buf, "mac\0")==0)
        if (buf[4]==',' || buf[4]==0 || buf[4]==' ')
        {
            if (buf[3]=='h')
            {
                *type = _MACH;
                return;
            }
            else if (buf[3]=='l')
            {
                *type = _MACL;
                return;
            }
        }
    else if (strsearch(buf, "pr\0")==0)
        if (buf[2]==',' || buf[2]==0 || buf[2]==' ')
        {
            *type = _PR;
            return;
        }
    else if (strsearch(buf, "pc\0")==0)
        if (buf[2]==',' || buf[2]==0 || buf[2]==' ')
        {
            *type = _PC;
            return;
        }
    else if (strsearch(buf, "sr\0")==0)
        if (buf[2]==',' || buf[2]==0 || buf[2]==' ')
        {
            *type = _SR;
            return;
        }

    for (i=0;1;i++)
    {
        current = buf[i];
        if (current==0)
        {
            tp = 21;
            break;
        }
        if (current==',' && parenthesis==0)
        {
            tp = 22;
            break;
        }
        if (current=='(')
            parenthesis++;
        if (current==')' && parenthesis>0)
            parenthesis--;

        if (current=='@')
        {
            tp = 1;
            i++;
            if (buf[i]=='(')
            {
                i++;
                result = searchValue(buf+i, &len, &found);
                if (found)
                {
                    i+=len;
                    dt = result&0xFFFF;
                    i+=strafeBetweenSpaces(buf+i);
                    i+=searchComma(buf+i)+1;
                    i+=strafeBetweenSpaces(buf+i);

                    if (strsearch(buf+i, "pc)\0")==0)
                    {
                        tp = 6;
                        break;
                    }
                    else if (strsearch(buf+i, "r\0")==0)
                    {
                        result = searchValue(buf+i+1, &len, &found);
                        if (found)
                        {
                            tp = 7;
                            dt |= (result<<16);
                            break;
                        }
                        else
                        {
                            tp = -17;
                            break;
                        }
                    }
                    else if (strsearch(buf+i, "gbr)\0")==0)
                    {
                        tp = 9;
                        break;
                    }
                    else
                    {
                        tp = -14;
                        break;
                    }
                }
                else if (strsearch(buf+i, "r0\0")==0)
                {
                    i+=2;
                    i+=strafeBetweenSpaces(buf+i);
                    i+=searchComma(buf+i)+1;
                    i+=strafeBetweenSpaces(buf+i);

                    if (strsearch(buf+i, "r\0")==0)
                    {
                        result = searchValue(buf+i, &len, &found);
                        if (found)
                        {
                            tp = 8;
                            dt = (int)result;
                        }
                        else
                            tp = -18;
                        break;
                    }
                    else if (strsearch(buf+i, "gbr)\0")==0)
                    {
                        tp = 10;
                        dt = 0;
                        break;
                    }
                    else
                    {
                        tp = -16;
                        break;
                    }
                }
                else
                {
                    tp = -15;
                    break;
                }
            }
            else
            {
                if (buf[i]=='-')
                {
                    tp = 2;
                    i++;
                }
                if (buf[i]=='r')
                {
                    result = searchValue(buf+i, &len, &found);
                    if (found)
                    {
                        dt = (int)result;
                        if (buf[i+1+len]=='+')
                        {
                            if (tp==2)
                                tp = -11;
                            else
                                tp = 3;
                        }
                    }
                    break;
                }
                else
                {
                    tp = -13;
                    break;
                }
            }
        }
        if (current=='r')
        {
            result = searchValue(buf+i+1, &len, &found);
            if (found)
            {
                tp = 0;
                dt = (int)result;
            }
            else
                tp = -19;
            break;
        }
        if (buf[i]=='*')
        {
            i++;
            for (len=0;1;len++)
            {
                if (!((buf[i+len]>='0' && buf[i+len]<='9') || (buf[i+len]>='a' && buf[i+len]<='f')))
                    break;
            }
            current = buf[i];
            if (current=='8' || current=='9' || (current>='a' && current<='f'))
                isNeg = 1;

            for (j=0;j<len;j++)
            {
                current = buf[i+j];
                if (current>='0' && current<='9')
                    nibble = current-'0';
                if (current>='a' && current<='f')
                    nibble = current-'a'+10;
                result+=(nibble<<((len-j-1)*4));
            }
            if (isNeg)
                for (j=0;j<8-len;j++)
                    result |= 0xF<<((7-j)*4);
            if (len==0)
                tp = -12;
            else
            {
                tp = 5;
                dt = (int)result;
            }
            break;
        }
        if (current=='-' || (current>='0' && current<='9'))
        {
            if (buf[i]=='-')
            {
                isNeg = 1;
                i++;
            }
            for (len=0;1;len++)
            {
                if (!(buf[i+len]>='0' && buf[i+len]<='9'))
                    break;
            }
            for (j=0;j<len;j++)
                result+=(pow10(len-j-1)*(buf[i+j]-'0'));

            if (isNeg)
            {
                result = ~result;
                result++;
            }
            if (len==0)
                tp = -12;
            else
            {
                tp = 5;
                dt = result;
            }
            break;
        }
    }

    *type = tp;
    *data = dt;
}

int searchComma (char *buf)
{
    int i = 0, parenthesis = 0;

    for (i=0;buf[i]!=0;i++)
    {
        if (buf[i]=='(')
                parenthesis++;
        if (buf[i]==')')
                parenthesis--;
        if (buf[i]==',' && parenthesis==0)
            return i;
    }

    return -1;
}

int strafeBetweenSpaces (char *buf)
{
    int i = 0;

    for (i=0;buf[i]!=0;i++)
        if (buf[i]!=' ')
            break;

    return i;
}

int fitsInSignedChar (int num)
{
    if (num<0)
    {
        num = ~num + 1;
        if (num<=128)
            return 1;
        else
            return 0;
    }
    else
    {
        if (num<=127)
            return 1;
        else
            return 0;
    }
}

int fitsInSignedNibble (short num)
{
    if (num<0)
    {
        num = ~num + 1;
        if (num<=8)
            return 1;
        else
            return 0;
    }
    else
    {
        if (num<=7)
            return 1;
        else
            return 0;
    }
}

int findLabelDisp (Edit edited, char *label, int currentLine, int *found)
{
    int i = 0, j = 0, idUp = currentLine, offUp = 0, idDown = currentLine, offDown = 0, len = 0;
    char *buffer = NULL;

    for (i=0;i<2048;i++)
    {
        idUp = currentLine-i;
        if (idUp>=0)
        {
            len = edited.length[idUp];
            if (len>0)
            {
                if (edited.base[idUp][len-1]==':')
                {
                    buffer = (char*)malloc(edited.length[idUp]+1);

                    strcpy(buffer, edited.base[idUp]);
                    buffer[edited.length[idUp]-1] = 0;

                    if (strcmp(buffer, label)==0)
                    {
                        free(buffer);
                        *found = 1;
                        return offUp+1;
                    }

                    free(buffer);
                }
                else if (edited.base[idUp][0]==' ')
                {
                    for (j=0;edited.base[idUp][j]!=0;j++)
                        if (edited.base[idUp][j]!=' ')
                        {
                            offUp--;
                            break;
                        }
                }
                else
                    offUp--;
            }
        }

        idDown = currentLine+i;
        if (idDown<edited.rows)
        {
            len = edited.length[idDown];
            if (len>0)
            {
                if (edited.base[idDown][len-1]==':')
                {
                    buffer = (char*)malloc(edited.length[idDown]+1);

                    strcpy(buffer, edited.base[idDown]);
                    buffer[edited.length[idDown]-1] = 0;

                    if (strcmp(buffer, label)==0)
                    {
                        free(buffer);
                        *found = 1;
                        return offDown;
                    }

                    free(buffer);
                }
                else if (edited.base[idDown][0]==' ')
                {
                    for (j=0;edited.base[idDown][j]!=0;j++)
                        if (edited.base[idDown][j]!=' ')
                        {
                            offUp++;
                            break;
                        }
                }
                else
                    offDown++;
            }
        }

        if (idUp<0 && idDown>=edited.rows)
            break;
    }

    *found = 0;
    return 0;
}

int fitsInBits (int number, int bits)
{
    int i = 0, maxValue = 1;

    for (i=0;i<bits;i++)
        maxValue*=2;

    maxValue/=2;

    if (number<0)
    {
        number = ~number+1;
        if (number>maxValue)
            return 0;
        else
            return 1;
    }
    else
    {
        if (number>(maxValue-1))
            return 0;
        else
            return 1;
    }
}

