
#ifndef ASSEMBLER_H
#define ASSEMBLER_H

#include "headers.h"

#define _RN 0
#define _AtRN 1
#define _AtMinRN 2
#define _AtRNPlus 3
#define _IMM 5
#define _AtDispPC 6
#define _AtDispRN 7
#define _AtR0RN 8
#define _AtDispGBR 9
#define _AtRNGBR 10
#define _GBR 11
#define _MACH 12
#define _MACL 13
#define _PR 14
#define _PC 15
#define _SR 16

int assembler (struct Edit *edited, struct BuildError *errors, char *name);
int strsearch (char *searched, char *toFind);
int searchValue (char *buf, int *length, char *found);
int pow10 (int pwr);
void searchArgv (char *buf, int *type, int *data);
int searchComma (char *buf);
int strafeBetweenSpaces (char *buf);
int fitsInSignedChar (int num);
int fitsInSignedNibble (short num);
int findLabelDisp (struct Edit edited, char *label, int currentLine, int *found);
int fitsInBits (int number, int bits);

#endif // ASSEMBLER_H
