
#include "headers.h"

int initErrors (BuildError *errors, int isASM)
{
    int i = 0, len = 0;

    errors->messages = getErrorMessages(isASM);
    if (errors->messages==NULL)
        return 0;

    errors->errors = NULL;
    errors->number = -1;

    return 1;
}

void addError (BuildError* errors, int line, int type)
{
    int i = 0, len = 0, place = 0;

    if (errors->number==-1)
        errors->number = 0;

    place = errors->number;

    errors->number++;
    if (place==0)
        errors->errors = (Error*)malloc(sizeof(Error));
    else
        errors->errors = (Error*)realloc(errors->errors, errors->number*sizeof(Error));

    errors->errors[place].lineStr = (char*)malloc(12);
    memcpy(errors->errors[place].lineStr, "l.", 2);
    i = itoa(errors->errors[place].lineStr+2, line, 0)+2;
    errors->errors[place].lineStr[i] = ':';
    errors->errors[place].lineStr[i+1] = 0;

    errors->errors[place].type = type;
    errors->errors[place].line = line;
}

void flushErrors (BuildError* errors)
{
    int i = 0,  errorsNumber = 0;

    if (errors!=NULL)
    {
        errorsNumber = errors->number;

        for (i=0;i<errorsNumber;i++)
            free(errors->errors[i].lineStr);

        free(errors->errors);
        errors->number = 0;
    }
}
