
#include "headers.h"

void saveFile (Edit edited, char *filename)
{
    int handle = 0, size = 0, sizeCurrent = 0, i = 0, j = 0, offset = 0, different = 0;
    FONTCHARACTER path[50]= {'\\','\\','f','l','s','0','\\','A','S','M','\\',0};
    unsigned char *buffer = NULL, *current = NULL;
    char **base = edited.base;
    int *length = edited.length, rows = edited.rows;

    for (i=0;i<rows;i++)
        size+=length[i]+1;

    size+=4;

    buffer = (unsigned char*)malloc(size);
    ((int*)buffer)[0] = rows;

    for (i=0;i<rows;i++)
        for (j=0;j<length[i]+1;j++)
        {
            buffer[offset+4] = base[i][j];
            offset++;
        }

    for (i=0;i<38;i++)
    {
        path[11+i] = filename[i];
        if (filename[i]==0)
            break;
    }

    handle = Bfile_OpenFile(path, _OPENMODE_READ);
    sizeCurrent = Bfile_GetFileSize(handle);
    if (size==sizeCurrent)
    {
        current = (unsigned char*)malloc(size);
        Bfile_ReadFile(handle, current, size, 0);

        for (i=0;i<size;i++)
            if (buffer[i]!=current[i])
            {
                different = 1;
                break;
            }

        free(current);
    }
    else
        different = 1;
    Bfile_CloseFile(handle);

    if (different)
    {
        Bfile_DeleteFile(path);
        Bfile_CreateFile(path, size);
        handle = Bfile_OpenFile(path, _OPENMODE_WRITE);
        Bfile_WriteFile(handle, buffer, size);
        Bfile_CloseFile(handle);
    }

    free(buffer);
}

void openFile (Edit *edited, char *filename)
{
    int handle = 0, size = 0, i = 0, j = 0, offset = 0, offsetSave = 0;
    FONTCHARACTER path[50]= {'\\','\\','f','l','s','0','\\','A','S','M','\\',0};
    unsigned char *buffer = NULL;
    char current = 0;
    int *length = edited->length, *alloc = edited->alloc, rows = edited->rows, rowsAlloc = edited->rowsAlloc;
    char **base = edited->base;

    for (i=0;i<38;i++)
    {
        path[11+i] = filename[i];
        if (filename[i]==0)
            break;
    }

    handle = Bfile_OpenFile(path, _OPENMODE_READ);
    if (handle>=0)
    {
        for (i=0;i<rows;i++)
            free(base[i]);

        free(base);
        free(length);
        free(alloc);

        size = Bfile_GetFileSize(handle);
        buffer = (unsigned char*)malloc(size);
        Bfile_ReadFile(handle, buffer, size, 0);
        Bfile_CloseFile(handle);

        rows = ((int*)buffer)[0];

        rowsAlloc = upperInt(rows, ALLOC_ROW);
        base = (char**)malloc(rowsAlloc*sizeof(char*));
        length = (int*)malloc(rowsAlloc*sizeof(int));
        alloc = (int*)malloc(rowsAlloc*sizeof(int));

        offset = 4;
        for (i=0;i<rows;i++)
        {
            current = 'a';
            for (j=0;current!=0;j++)
                current = buffer[offset+j];

            length[i] = j-1;
            alloc[i] =  j;
            base[i] = (char*)malloc(alloc[i]);

            current = 'a';
            for (j=0;current!=0;j++)
            {
                current = buffer[offset+j];
                base[i][j] = current;
            }
            offset+=j;
        }

        free(buffer);
    }
    else
    {
        while(1);
    }

    edited->base = base;
    edited->length = length;
    edited->alloc = alloc;
    edited->rows = rows;
    edited->rowsAlloc = rowsAlloc;
}

void deleteFile (char **path, int *fileSize, int fileNumber, int *totalFiles)
{
    FONTCHARACTER filepath[50]= {'\\','\\','f','l','s','0','\\','A','S','M','\\',0};
    int i = 0;

    for (i=0;i<38;i++)
    {
        filepath[11+i] = path[fileNumber][i];
        if (path[fileNumber][i]==0)
            break;
    }

    Bfile_DeleteFile(filepath);
    free(path[fileNumber]);

    for (i=fileNumber;i<*totalFiles;i++)
    {
        path[i] = path[i+1];
        fileSize[i] = fileSize[i];
    }

    (*totalFiles)--;
}

char** loadFileIndex (int *totalFiles, int **sizes)
{
    FONTCHARACTER path[50]= {'\\','\\','f','l','s','0','\\','A','S','M','\\',0};
    FONTCHARACTER meta[] = {'\\','\\','f','l','s','0','\\','A','S','M','\\','m','e','t','a','.','t','x','t',0};
    FONTCHARACTER dir[] = {'\\','\\','f','l','s','0','\\','A','S','M',0};
    int handle = 0, files = 0, erasedOffset = 0, size = 0, i = 0, j = 0, offset = 0, *fileSize, toOverwrite = 0;
    char **data = NULL, *buffer;

    handle = Bfile_OpenFile(meta, _OPENMODE_READ);
    if (handle<0)
    {
        Bfile_CreateDirectory(dir);
        Bfile_CreateFile(meta, 4);
        handle = Bfile_OpenFile(meta, _OPENMODE_WRITE);
        Bfile_WriteFile(handle, &i, 4);
        Bfile_CloseFile(handle);
    }
    else
    {
        size = Bfile_GetFileSize(handle);
        buffer = (char*)malloc(size);
        Bfile_ReadFile(handle, buffer, size, 0);
        Bfile_CloseFile(handle);
        files = ((int*)buffer)[0];
        data = (char**)malloc(files*sizeof(char*));
        fileSize = (int*)malloc(files*sizeof(int));

        offset = 4;
        for (i=0;i<files;i++)
        {
            for (j=0;buffer[offset+j]!=0;j++);

            if (!toOverwrite)
                data[i-erasedOffset] = (char*)malloc(j+1);
            else
            {
                data[i-erasedOffset] = (char*)realloc(data[i], j+1);
                toOverwrite = 0;
            }

            for (j=0;1;j++)
            {
                data[i-erasedOffset][j] = buffer[offset+j];
                if (buffer[offset+j]==0)
                    break;
            }

            for (j=0;j<38;j++)
            {
                path[11+j] = data[i-erasedOffset][j];
                if (data[i-erasedOffset][j]==0)
                    break;
            }

            handle = Bfile_OpenFile(path, _OPENMODE_READ);
            if (handle>=0)
            {
                fileSize[i-erasedOffset] = Bfile_GetFileSize(handle);
                Bfile_CloseFile(handle);
            }
            else
            {
                erasedOffset++;
                toOverwrite = 1;
            }

            offset+=j+1;
        }

        free(buffer);
        *sizes = fileSize;
    }
    *totalFiles = files-erasedOffset;
    return data;
}

void updateFileSize (int *fileSize, char **paths, int fileSelected)
{
    FONTCHARACTER path[50]= {'\\','\\','f','l','s','0','\\','A','S','M','\\',0};
    int i = 0, handle;

    for (i=0;i<38;i++)
    {
        path[11+i] = paths[fileSelected][i];
        if (paths[fileSelected][i]==0)
            break;
    }

    handle = Bfile_OpenFile(path, _OPENMODE_READ);
    fileSize[fileSelected] = Bfile_GetFileSize(handle);
    Bfile_CloseFile(handle);
}

void saveFileIndex (char **path, int totalFiles)
{
    FONTCHARACTER meta[] = {'\\','\\','f','l','s','0','\\','A','S','M','\\','m','e','t','a','.','t','x','t',0};
    int handle = 0, i = 0, j = 0, offset = 0;
    char *buffer;

    for (i=0;i<totalFiles;i++)
        offset+=strlen(path[i])+1;

    buffer = (char*)malloc(offset+4);

    offset = 0;
    for (i=0;i<totalFiles;i++)
    {
        for (j=0;1;j++)
        {
            buffer[offset+j+4] = path[i][j];
            if (path[i][j]==0)
                break;
        }
        offset+=j+1;
    }

    ((int*)buffer)[0] = totalFiles;

    Bfile_DeleteFile(meta);
    Bfile_CreateFile(meta, offset+4);
    handle = Bfile_OpenFile(meta, _OPENMODE_WRITE);
    Bfile_WriteFile(handle, buffer, offset+4);
    Bfile_CloseFile(handle);
}

int selectFile (char ***file, int *totalFiles, int **fileSizeOri, int cur, Edit edited)
{
    int i = 0, nb = *totalFiles, size = 0, length = 0, buf = 0, *fileSize, cam = cur-1, current = cur;
    unsigned int key = 0;
    char newpath[13] = {0}, **files = *file, buffer[20];

    fileSize = *fileSizeOri;

    if (cur==-1)
        cur = 0;

    if (cam<0)
        cam = 0;
    if (cur>=nb)
        cur = nb-1;

    while (1)
    {
        if (key==KEY_CTRL_UP)
        {
            cur--;
            if (cur<0)
                cur = 0;

            if (cur==cam)
                cam--;
            if (cam<0)
                cam = 0;
        }
        if(key==KEY_CTRL_DOWN)
        {
            cur++;
            if (cur>=nb)
                cur = nb-1;
            if (cur==cam+6)
                cam++;
        }
        if (key==KEY_CTRL_F1 && current!=-1)
            if (doSave(files[current], 0))
            {
                saveFile(edited, files[current]);
                updateFileSize(fileSize, files, current);
            }
        if (key==KEY_CTRL_F6)
        {
            if (getstring(newpath, 13, 1))
            {
                if (!doesAlreadyExist(newpath, files, nb))
                {
                    cur = nb;
                    nb++;
                    fileSize = (int*)realloc(fileSize, nb*sizeof(int));
                    fileSize[nb-1] = 5;
                    createEmptyFile(newpath);
                    files = (char**)realloc(files, nb*sizeof(char*));
                    size = strlen(newpath)+1;
                    files[nb-1] = (char*)malloc(size);
                    memcpy(files[nb-1], newpath, size);

                    saveFileIndex(files, nb);
                }
            }
        }
        if (key==KEY_CTRL_F5)
            if (doSave(files[cur], 1) && nb!=0)
            {
                deleteFile(files, fileSize, cur, &nb);
                if (current==cur)
                    current = -1;
                if (cur>nb-1)
                    cur = nb-1;
            }

        if(key==KEY_CTRL_EXIT)
        {
            *file = files;
            *totalFiles = nb;
            *fileSizeOri = fileSize;
            if (current==-1)
                return -2;
            return -1;
        }
        if(key==KEY_CTRL_EXE && nb!=0)
            break;

        ML_clear_vram();

        if (nb)
        {
            for (i=0;i<7;i++)
            {
                if (i+cam==nb)
                    break;

                locate(4, i+1);
                Print((unsigned char*)files[i+cam]);

                buf = fileSize[i+cam];
                if (buf<1000)
                    sprintf(buffer, "%d B\0", buf);
                else
                    sprintf(buffer, "%d kB\0", buf/1000);
                length = strlen(buffer);

                locate(22-length, i+1);
                Print((unsigned char*)buffer);
            }


            locate(2, cur+1-cam);
            Print((unsigned char*)">\0");
        }
        else
        {
            locate(1, 1);
            Print((unsigned char*)"No file found yet !\0");
            locate(1, 2);
            Print((unsigned char*)"You can create one");
            locate(1, 3);
            Print((unsigned char*)"using [New] (F6).\0");
        }

        locate(17, 8);
        PrintRev((unsigned char*)"[New]\0");

        if (current!=-1)
        {
            locate(1, 8);
            PrintRev((unsigned char*)files[current]);
        }

        ML_display_vram();

        while(IsKeyDown(KEY_CTRL_EXIT));
        GetKey(&key);
    }

    *file = files;
    *totalFiles = nb;
    *fileSizeOri = fileSize;
    return cur;
}

int getstring(char *buffer, int size, int doExt)
{
    int i = 0, cur = 0, sizeCurrent = 0, displayWarning = 0, done = 1, caps = 1;
    unsigned int key = 0;

    buffer[0] = 0;
    while(1)
    {
        if (key==KEY_CTRL_LEFT)
        {
            cur--;
            if (cur<0)
                cur = 0;
        }
        if (key==KEY_CTRL_RIGHT)
        {
            cur++;
            if (cur>sizeCurrent)
                cur = sizeCurrent;
        }
        if (key==KEY_CTRL_VARS)
            caps = !caps;

        if (key==KEY_CTRL_EXE)
        {
            if (doExt)
            {
                done = 0;
                for (i=0;i<sizeCurrent+1;i++)
                {
                    if (buffer[i]==0)
                    {
                        if (i<size-4)
                        {
                            memcpy(buffer+i, ".asm\0", 5);
                            done = 1;
                            break;
                        }
                        else
                            displayWarning = 2;
                    }
                    if (buffer[i]=='.')
                    {
                        if (i>8)
                            displayWarning = 2;
                        else
                            done = 1;
                        break;
                    }
                }
                if (done==1 && !strcmp(&buffer[i], ".asm\0"))
                {
                    while(IsKeyDown(KEY_CTRL_EXE));
                    break;
                }
                else
                    if (displayWarning!=2)
                        displayWarning = 1;
            }
        }

        if (sizeCurrent<(size-1) && ((key>=KEY_CHAR_A && key<=KEY_CHAR_Z) || (key>=KEY_CHAR_0 && key<=KEY_CHAR_9) || key==KEY_CHAR_DP || key==KEY_CHAR_MINUS || key==KEY_CHAR_PLUS || key==KEY_CHAR_MULT || key==KEY_CHAR_DIV || key==KEY_CHAR_SPACE || key==KEY_CHAR_EXP || key==KEY_CHAR_COMMA || key==KEY_CHAR_LBRCKT || key==KEY_CHAR_RBRCKT || key==KEY_CHAR_LBRACE || key==KEY_CHAR_RBRACE || key==KEY_CHAR_LPAR || key==KEY_CHAR_RPAR))
        {
            for (i=sizeCurrent+1;i>cur;i--)
                buffer[i] = buffer[i-1];
            if (key>=KEY_CHAR_A && key<=KEY_CHAR_Z)
                buffer[cur] = key+32*caps;
            else
                if (key>=KEY_CHAR_0 && key<=KEY_CHAR_9)
                    buffer[cur] = key;
            else
                if (key==KEY_CHAR_DP)
                    buffer[cur] = '.';
            else
                if (key==KEY_CHAR_COMMA)
                    buffer[cur] = ',';
            else
                if (key==KEY_CHAR_MINUS)
                    buffer[cur] = '-';
            else
                if (key==KEY_CHAR_PLUS)
                    buffer[cur] = '+';
            else
                if (key==KEY_CHAR_DIV)
                    buffer[cur] = '/';
            else
                if (key==KEY_CHAR_MULT)
                    buffer[cur] = '*';
            else
                if (key==KEY_CHAR_SPACE)
                    buffer[cur] = ' ';
            else
                if (key==KEY_CHAR_EXP)
                    buffer[cur] = ':';
            else
                if (key==KEY_CHAR_LBRCKT)
                    buffer[cur] = '[';
            else
                if (key==KEY_CHAR_RBRCKT)
                    buffer[cur] = ']';
            else
                if (key==KEY_CHAR_LBRACE)
                    buffer[cur] = '{';
            else
                if (key==KEY_CHAR_RBRACE)
                    buffer[cur] = '}';
            else
                if (key==KEY_CHAR_LPAR)
                    buffer[cur] = '(';
            else
                if (key==KEY_CHAR_RPAR)
                    buffer[cur] = ')';
            sizeCurrent++;
            cur++;
        }
        if (key==KEY_CTRL_DEL && cur>0)
        {
            for (i=cur;i<sizeCurrent;i++)
                buffer[i] = buffer[i+1];

            sizeCurrent--;
            buffer[sizeCurrent] = 0;
            cur--;
        }
        if (key==KEY_CTRL_EXIT)
            return 0;

        ML_clear_vram();

        locate(1, 1);
        Print((unsigned char*)"New file name :\0");
        locate(1, 2);
        Print((unsigned char*)buffer);
        locate(cur+1, 2);
        Print((unsigned char*)"|\0");

        if (displayWarning==1)
        {
            locate(1, 4);
            Print((unsigned char*)"Format : *.asm\0");
            displayWarning = 0;
        }
        else
            if (displayWarning==2)
            {
                locate(1, 4);
                Print((unsigned char*)"File name too long :/\0");
                displayWarning = 0;
            }

        ML_display_vram();
        GetKey(&key);
    }

    return 1;
}

int doSave (char *filename, int mode)
{
    int ans = 1, len = 0;
    unsigned int key = 0;

    len = strlen(filename);

    ML_clear_vram();

    locate(1, 1);
    Print((unsigned char*)"Hey.\0");
    locate(1, 2);
    if (mode==0)
    {
        Print((unsigned char*)"Save\0");
        locate(6, 2);
        PrintRev((unsigned char*)filename);
        locate(7+len, 2);
        Print((unsigned char*)"?\0");
        locate(2, 4);
        Print((unsigned char*)">\0");
    }
    if (mode==1)
    {
        ans = 0;
        Print((unsigned char*)"Delete\0");
        locate(8, 2);
        PrintRev((unsigned char*)filename);
        locate(9+len, 2);
        Print((unsigned char*)"?\0");
        locate(2, 5);
        Print((unsigned char*)">\0");
    }

    locate(4, 4);
    Print((unsigned char*)"Yes\0");
    locate(4, 5);
    Print((unsigned char*)"No\0");

    ML_display_vram();

    while(IsKeyDown(KEY_CTRL_EXE));

    while(1)
    {
        GetKey(&key);

        if (key==KEY_CTRL_UP)
            ans = 1;
        if (key==KEY_CTRL_DOWN)
            ans = 0;

        if (key==KEY_CTRL_EXE)
            break;

        locate(2, 4+!ans);
        Print((unsigned char*)">\0");
        locate(2, 4+ans);
        Print((unsigned char*)" \0");
    }

    return ans;
}

void createEmptyFile (char *filename)
{
    FONTCHARACTER path[50]= {'\\','\\','f','l','s','0','\\','A','S','M','\\',0};
    int i = 0, handle = 0;
    char data[] = {0, 0, 0, 1, 0};

    for (i=0;i<38;i++)
    {
        path[11+i] = filename[i];
        if (filename[i]==0)
            break;
    }

    Bfile_CreateFile(path, 5);
    handle = Bfile_OpenFile(path, _OPENMODE_WRITE);
    Bfile_WriteFile(handle, data, 5);
    Bfile_CloseFile(handle);
}

int doesAlreadyExist (char *filename, char **path, int files)
{
    int i = 0, ans = 0;

    for (i=0;i<files;i++)
        if (!strcmp(filename, path[i]))
        {
            ans = 1;
            break;
        }

    if (ans)
    {
        locate(1, 3);
        Print((unsigned char*)"This files does\0");
        locate(1, 4);
        Print((unsigned char*)"already exist.\0");
        ML_display_vram();

        while(IsKeyDown(KEY_CTRL_EXE));
        while(!IsKeyDown(KEY_CTRL_EXE));
    }

    return ans;
}

int itoa(char *buf, int num, char isHexa)
{
    int i = 0, a = 0, len = 0, isNeg = 0;
    char temp[12] = {0};

    if (!isHexa)
    {
        if (num==0)
        {
            buf[0] = '0';
            return 1;
        }

        if (num<0)
        {
            isNeg = 1;
            num = -num;
        }

        for (i=0;1;i++)
        {
            a = num/pow10(i);
            if (num%pow10(i)==num)
                break;

            temp[i] = a%10;
        }

        len = i;

        if (isNeg)
            buf[0] = '-';

        for (i=0;i<len;i++)
            buf[i+isNeg] = temp[len-i-1]+'0';

        return len+isNeg;
    }
    else
    {
        len = isHexa>>2;    // Hexa form displays a certain number of nibbles, syntax : isHexa | (nibblesToDisplay<<2)
        for (i=0;i<len;i++)
        {
            a = (num>>((len-1-i)*4))&0xF;
            if (a>=0 && a<=9)
                buf[i] = a + '0';
            else
                buf[i] = a - 0xA + 'A';
        }

        return len;
    }
}

char** getErrorMessages (int isASM)
{
    int handle = 0, header[2] = {0}, size = 0, pos = 0, errors = 0, i = 0, len = 0;
    FONTCHARACTER path[50]= {'\\','\\','f','l','s','0','\\','E','D','I','T','A','S','M','.','d','a','t',0};
    char **messages = NULL, *buffer = NULL;

    handle = Bfile_OpenFile(path, _OPENMODE_READ);
    if (handle<0)
        return NULL;
    Bfile_ReadFile(handle, header, 2*sizeof(int), 0);

    size = header[1]-header[0];
    buffer = (char*)malloc(size);
    Bfile_ReadFile(handle, buffer, size, header[0]);
    Bfile_CloseFile(handle);

    pos = ((int*)buffer)[!isASM];
    errors = *((int*)(buffer+pos));
    pos+=4;
    messages = (char**)malloc(errors*sizeof(char*));

    for (i=0;i<errors;i++)
    {
        len = strlen(buffer+pos)+1;
        messages[i] = (char*)malloc(len);
        memcpy(messages[i], buffer+pos, len);
        pos+=len;
    }

    for (i=0;i<size;i++)
        buffer[i] = 0;

    free(buffer);
    return messages;
}
